//-----------------------------------------------------------------
#property copyright "http://www.forex-tsd.com"
#property link      "http://www.forex-tsd.com"
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  LimeGreen
#property  indicator_color2  Gold
#property  indicator_width1  2
//-----------------------------------------------------------------

extern string TimeFrame = "Current time frame";
extern int pq =2;
extern int pr = 10;
extern int ps = 5;
extern int trigger =3;

double ErgoCCI[];
double MainCCI[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,ErgoCCI);   SetIndexLabel(0,"Egodic CCI");
   SetIndexBuffer(1,MainCCI);   SetIndexLabel(1,"Trigger Line");
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
   return(0);
}
int start()
{
   string signal;
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ErgoCCI[0] = limit+1; return(0); }
         if (timeFrame!=Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  ErgoCCI[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,0,y);
                  MainCCI[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",pq,pr,ps,trigger,1,y);
            }
            return(0);                  
         }

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double var1  = iEma(iEma(iEma(        Close[i]-Close[i+1] ,pq,i,0),pr,i,1),ps,i,2);
      double var2  = iEma(iEma(iEma(MathAbs(Close[i]-Close[i+1]),pq,i,3),pr,i,4),ps,i,5);
         if (var2 != 0)
               ErgoCCI[i] = 500.0 * var1/var2;
         else  ErgoCCI[i] = 0;
               MainCCI[i] = iEma(ErgoCCI[i],trigger,i,6);
   }
   if (MainCCI[0] >  ErgoCCI[0]) signal = "SHORT";
   if (MainCCI[0] <  ErgoCCI[0]) signal = "LONG";
   if (MainCCI[0] == ErgoCCI[0]) signal = "NEUTRAL";
      IndicatorShortName(timeFrameToString(timeFrame)+" FX Sniper's Ergodic CCI & Trigger: "+signal);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][7];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r=Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}